from scipy._typing import Untyped
from scipy.linalg import get_blas_funcs as get_blas_funcs, issymmetric as issymmetric

class HessianUpdateStrategy:
    def initialize(self, n, approx_type): ...
    def update(self, delta_x, delta_grad): ...
    def dot(self, p): ...
    def get_matrix(self): ...

class FullHessianUpdateStrategy(HessianUpdateStrategy):
    init_scale: Untyped
    first_iteration: Untyped
    approx_type: Untyped
    B: Untyped
    H: Untyped
    def __init__(self, init_scale: str = "auto"): ...
    n: Untyped
    def initialize(self, n, approx_type): ...
    def update(self, delta_x, delta_grad): ...
    def dot(self, p) -> Untyped: ...
    def get_matrix(self) -> Untyped: ...

class BFGS(FullHessianUpdateStrategy):
    min_curvature: Untyped
    exception_strategy: Untyped
    def __init__(
        self, exception_strategy: str = "skip_update", min_curvature: Untyped | None = None, init_scale: str = "auto"
    ): ...

class SR1(FullHessianUpdateStrategy):
    min_denominator: Untyped
    def __init__(self, min_denominator: float = 1e-08, init_scale: str = "auto"): ...
